-- Registration Filltypes Kastor Sawmill Pack for selling stations
-- Permission for use / modifying granted by derelky 
-- taken from
-- MoreBunkersilo Mod by derelky
-- (Help to register new fillTypes by Wopster)
-- Version 1.0 initial release for Kastor SMP

local modDirectory = g_currentModDirectory

function onLoadMapFinished(mission, node)

    if node ~= 0 then
        local priceWoodChips = g_fillTypeManager:getFillTypeByName("WOODCHIPS").pricePerLiter
        local priceWool = g_fillTypeManager:getFillTypeByName("WOOL").pricePerLiter
        		
		
        local barkMulchHudFile = "fruits/hud_fill_barkMulch.dds"
        local barkMulchHudFileSmall = "fruits/hud_fill_barkMulch_sml.dds"
        
		local boardsPalletHudFile = "fruits/hud_fill_boardsPallet.dds"
        local boardsPalletHudFileSmall = "fruits/hud_fill_boardsPallet_sml.dds"
		local emptyPalletHudFile = "fruits/hud_fill_emptyPallet.dds"
        local emptyPalletHudFileSmall = "fruits/hud_fill_emptyPallet_sml.dds"
        local woodBeamsHudFile = "fruits/hud_fill_woodBeams.dds"
		local woodBeamsHudFileSmall = "fruits/hud_fill_woodBeams_sml.dds"
		
		local barkMulchHeapDiffuse = Utils.getFilename("textures/mulch_diffuse.dds", modDirectory)
        local barkMulchHeapnormal  = Utils.getFilename("textures/woodChips_normal.dds", modDirectory)  
        local barkMulchHeapdistance = Utils.getFilename("textures/woodChipsDistance_diffuse.dds", modDirectory)  
		
        	
		--register Fill and Densitymap
		print("Register filltype: barkmulch, woodbeams, empty pallets and boards pallets")
        local barkMulchFilType = g_fillTypeManager:addFillType("barkMulch", g_i18n:getText("fillType_barkMulch"), true, priceWoodChips, 0.65, math.rad(15), barkMulchHudFile, barkMulchHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local boardsPalletFilType = g_fillTypeManager:addFillType("boardsPallet", g_i18n:getText("fillType_boardsPallet"), false, priceWoodChips * 2.2, 0.76, math.rad(15), boardsPalletHudFile, boardsPalletHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local emptyPalletFilType = g_fillTypeManager:addFillType("emptyPallet", g_i18n:getText("fillType_emptyPallet"), true, priceWoodChips * 3.5, 0.3, math.rad(15), emptyPalletHudFile, emptyPalletHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local woodBeamsFilType = g_fillTypeManager:addFillType("woodBeams", g_i18n:getText("fillType_woodBeams"), false, priceWoodChips * 5.2, 0.86, math.rad(15), woodBeamsHudFile, woodBeamsHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
		
		local barkMulchHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("barkMulch", math.rad(15), 1, 0, 0, 1, 1, false, barkMulchHeapDiffuse, barkMulchHeapnormal, barkMulchHeapdistance, false)
				
		--load MaterialHolder		
		loadI3DFile(modDirectory .. "holder/fillPlane_materialHolder.i3d")
		loadI3DFile(modDirectory .. "PS/barkMulchPS.i3d")	
		loadI3DFile(modDirectory .. "holder/effect_materialHolder.i3d")	

		--add the new Filltypes to FillCategorys so it can be load in it
		local SMPCategory = {"PIECE"}
		local BMCategory = {"BULK", "LOADINGVEHICLE", "SILAGETRAILER", "FORAGEHARVESTER"}
		
		for _,k in pairs(SMPCategory) do
			g_fillTypeManager:addFillTypeToCategory(emptyPalletFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
			g_fillTypeManager:addFillTypeToCategory(boardsPalletFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
			g_fillTypeManager:addFillTypeToCategory(woodBeamsFilType.index, g_fillTypeManager.nameToCategoryIndex[k])
		end
		
		for _,j in pairs(BMCategory) do
			g_fillTypeManager:addFillTypeToCategory(barkMulchFilType.index, g_fillTypeManager.nameToCategoryIndex[j])	
		end
		
		-- refresh FilltypeManager
        g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)
		
	end
	
end


function addtoseasonseconomy(mission)
		if g_seasons == nil then
			else
				if g_seasons.economy.data.repricing.fillTypes.barkMulch  == nil then
					g_seasons.economy.data.repricing.fillTypes.barkMulch = {}
					for i,j in pairs(g_seasons.economy.data.repricing.fillTypes.WOODCHIPS) do
					g_seasons.economy.data.repricing.fillTypes.barkMulch[i]=j
					end
				end
				if g_seasons.economy.data.repricing.fillTypes.woodBeams  == nil then
					g_seasons.economy.data.repricing.fillTypes.woodBeams = {}
					for i,k in pairs(g_seasons.economy.data.repricing.fillTypes.WOODCHIPS) do
					g_seasons.economy.data.repricing.fillTypes.woodBeams[i]=k
					end
				end
				if g_seasons.economy.data.repricing.fillTypes.emptyPallet  == nil then
					g_seasons.economy.data.repricing.fillTypes.emptyPallet = {}
					for i,k in pairs(g_seasons.economy.data.repricing.fillTypes.WOODCHIPS) do
					g_seasons.economy.data.repricing.fillTypes.emptyPallet[i]=k
					end
				end
				if g_seasons.economy.data.repricing.fillTypes.boardsPallet  == nil then
					g_seasons.economy.data.repricing.fillTypes.boardsPallet = {}
					for i,k in pairs(g_seasons.economy.data.repricing.fillTypes.WOODCHIPS) do
					g_seasons.economy.data.repricing.fillTypes.boardsPallet[i]=k
					end
				end
		end
end

function load(id, xmlFile, key, customEnvironment)
	-- Add the new Filltype to the SellingStations
		local haswool =false
		local haswoodchips =false
		local hasbarkmulch =false
		local hasemptypallet =false
		local hasboardspallet =false
		local haswoodbeams =false
		
		local object=id
			
		
		if object == nil then
		else
		haswool =false
		haswoodchips =false
		hasbarkmulch =false
		hasemptypallet =false
		hasboardspallet =false
		haswoodbeams =false
		
			for i,filltype in pairs(object.acceptedFillTypes) do
					
			local fillname=g_fillTypeManager.indexToName[i]

			if fillname == "WOOL" then
				haswool =true
							
			end
			if fillname == "WOODCHIPS" then
				haswoodchips =true
							
			end

			if fillname == "barkMulch" then
				hasbarkmulch =true
							
			end
			if fillname == "emptyPallet" then
				hasemptypallet =true
							
			end
			
			if fillname == "boardsPallet" then
				hasboardspallet =true
			
			end
			
			if fillname == "woodBeams" then
				haswoodbeams =true
				
			end
			
			
			if haswoodchips and not hasbarkmulch then
				--add BARKMULCH to the same SellingStation that accept WOODCHIPS
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("barkMulch")
				local price = g_fillTypeManager:getFillTypeByName("barkMulch").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("barkMulch")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WOODCHIPS")]
				object:initPricingDynamics()
			end
			
			if haswoodchips and not hasemptypallet then
				--add EMPTY PALLET to the same SellingStation that accept WOODCHIPS
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("emptyPallet")
				local price = g_fillTypeManager:getFillTypeByName("emptyPallet").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("emptyPallet")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WOODCHIPS")]
				object:initPricingDynamics()
			end
			
			if haswool and not hasemptypallet then
				--add EMPTY PALLET to the same SellingStation that accept WOOL
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("emptyPallet")
				local price = g_fillTypeManager:getFillTypeByName("emptyPallet").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("emptyPallet")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WOOL")]
				object:initPricingDynamics()
			end
			
			if haswoodchips and not hasboardspallet then
				--add BOARDS PALLET to the same SellingStation that accept WOODCHIPS
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("boardsPallet")
				local price = g_fillTypeManager:getFillTypeByName("boardsPallet").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("boardsPallet")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WOODCHIPS")]
				object:initPricingDynamics()
			end
			
			if haswoodchips and not haswoodbeams then
				--add WOOD BEAMS to the same SellingStation that accept WOODCHIPS
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("woodBeams")
				local price = g_fillTypeManager:getFillTypeByName("woodBeams").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("woodBeams")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WOODCHIPS")]
				object:initPricingDynamics()
			end
		end	
	end
end

-- Hook here
FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, onLoadMapFinished)
Mission00.loadItemsFinished = Utils.prependedFunction(Mission00.loadItemsFinished, addtoseasonseconomy)
SellingStation.load = Utils.appendedFunction(SellingStation.load, load)
